//George Zhao

import TerminalIO.KeyboardReader;
import java.util.*;

public class Calendar
{
	public static void main(String[] args)
	{
		KeyboardReader reader = new KeyboardReader();
		while(true)
		{
			System.out.println("Main Menu");
			System.out.println("\tprogram #1: Display Day of Week");
			System.out.println("\tprogram #2: Display Month Calendar");
			System.out.println("\tprogram #3: Floating Holidays");
			
			System.out.println("\tprogram #0: Exit");			
			int selection = reader.readInt("Enter your Selection: ");
			
			if(selection == 1)
			{
				int year = reader.readInt("\nEnter the year: ");
				int month = reader.readInt("Enter the month: ");
				int day = reader.readInt("Enter the date: ");
				int answer = dayOfWeek(year, month, day);
				String result = "\n";
				
				if(answer == 0)
					result = "Sunday";
				else if(answer == 1)
					result = "Monday";
				else if(answer == 2)
					result = "Tuesday";
				else if(answer == 3)
					result = "Wednesday";
				else if(answer == 4)
					result = "Thursday";
				else if(answer == 5)
					result = "Friday";
				else
					result = "Saturday";
								
				System.out.println(result + "\n");
			}
			
			else if(selection == 2)
			{
				int year = reader.readInt("\nEnter the year: ");
				int month = reader.readInt("Enter the month: ");
				int[] num_of_days_by_month = {31,28,31,30,31,30,31,31,30,31,30,31}; //Jan to Dec
				int num_of_days_in_this_month = num_of_days_by_month[month-1];
				if(month == 2 && isLeapYear(year))
					num_of_days_in_this_month++;
				int cursor_counter = 0;
				System.out.println("\nSUN\tMON\tTUES\tWED\tTHURS\tFRI\tSAT");
				for(int i=0; i<dayOfWeek(year, month, 1); i++)	//day 1 of the month
				{
					System.out.print("\t");
					cursor_counter++;
				}
				for(int j=1; j<=num_of_days_in_this_month; j++)
				{
					System.out.print(j+"\t");
					cursor_counter++;
					if(cursor_counter%7 == 0)
						System.out.println();
				}
				System.out.println("\n");
			}
			
			else if(selection == 3)
			{
				int year = reader.readInt("\nEnter the year: ");
				int[] dates = new int[6];
				
				int mlk_count = 0;	//MLK Day- 3rd Monday of January
				for(int i=1; i<=31; i++)
				{
					if(dayOfWeek(year, 1, i) == 1)
						mlk_count++;
					if(mlk_count == 3)
					{
						dates[0] = i;
						break;
					}
				}
				
				int prez_count = 0;	//Presidents Day- 3rd Monday of February
				for(int i=1; i<=29; i++)
				{
					if(dayOfWeek(year, 2, i) == 1)
						prez_count++;
					if(prez_count == 3)
					{
						dates[1] = i;
						break;
					}
				}

				for(int i=31; i>=1; i--)	//Memorial Day- last Monday of May
				{
					if(dayOfWeek(year, 5, i) == 1)
					{
						dates[2] = i;
						break;
					}
				}
				
				for(int i=1; i<=30; i++)	//Labor Day- 1st Monday of September
				{
					if(dayOfWeek(year, 9, i) == 1)
					{
						dates[3] = i;
						break;
					}
				}
				
				for(int i=1; i<=30; i++)	//Election Day- Tuesday after 1st Monday of November
				{
					if(dayOfWeek(year, 11, i) == 1)
					{
						dates[4] = 1+i;
						break;
					}
				}		

				int thnx_count = 0;	//Thanksgiving Day- 4th Thursday of November
				for(int i=1; i<=30; i++)
				{
					if(dayOfWeek(year, 11, i) == 4)
						thnx_count++;
					if(thnx_count == 4)
					{
						dates[5] = i;
						break;
					}
				}
				
				String[] converted_dates = new String[6];	//dealing with dates < 10
				for(int i=0; i<dates.length; i++)
				{
					if(dates[i] < 10)
						converted_dates[i] = "0" + dates[i];
					else
						converted_dates[i] = "" + dates[i];
				}
				
				System.out.println("Year: " + year);	//dealing with years < 1000
				String extra_zeroes = "";
				for(int i=0; i<3-(int)(Math.log(year)/Math.log(10)); i++)
					extra_zeroes += "0"	;
				
				System.out.println("\nMLK Day: 01/" + converted_dates[0] + "/" + extra_zeroes + year);
				System.out.println("Presidents Day: 02/" + converted_dates[1] + "/" + extra_zeroes + year);
				System.out.println("Memorial Day: 05/" + converted_dates[2] + "/" + extra_zeroes + year);	
				System.out.println("Labor Day: 09/" + converted_dates[3] + "/" + extra_zeroes + year);
				System.out.println("Election Day: 11/" + converted_dates[4] + "/" + extra_zeroes + year);
				System.out.println("Thanksgiving Day: 11/" + converted_dates[5] + "/" + extra_zeroes + year + "\n");				
			}
			
			else
				System.exit(0);
		}
	}
	
	public static boolean isLeapYear(int year)
	{
		return year%4 == 0 && (year%100 != 0 || year%400 == 0);
	}
	
	public static int nthDateOfyear(int year, int month, int day)
	{
		int[] num_of_days_by_month = {31,28,31,30,31,30,31,31,30,31,30}; //Jan to Nov
		int result = 0;
		for(int i=0; i<month-1; i++)	//preceding months
			result += num_of_days_by_month[i];
		result += day;		
		if(isLeapYear(year) && month > 2)	//leap year accomodation
			result++;
		return result;
	}
	
	public static int dayOfWeekForJan1(int year)
	{
		int result = 4;		
		if(year == 2009)	//base year
			return result;
		boolean greater = year > 2009;
		
		if(greater)	//later than 2009
		{
			for(int i=2009; i<year; i++)
			{
				if(!isLeapYear(i))
					result++;
				else
					result += 2;
			}
		}
		else	//earlier than 2009
		{
			for(int i=2009; i>year; i--)
			{
				if(isLeapYear(i-1))
					result -= 2;
				else
					result--;
			}
		}
		
		return (result+7777777)%7;
	}
	
	public static int dayOfWeek(int year, int month, int day)
	{
		return (nthDateOfyear(year, month, day) + dayOfWeekForJan1(year) - 1)%7;
	}	
}